<?php
namespace Siteguarding\Antivirus\Setup;

use Magento\Framework\Setup\InstallDataInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;
use Magento\Framework\Setup\ModuleContextInterface;

use Magento\Framework\App\ObjectManager;


class InstallData implements InstallDataInterface  {
	
	public function install( ModuleDataSetupInterface $setup, ModuleContextInterface $context ) {
		
		if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN'){
			$dirsep = "\\";
		} else {
			$dirsep = "/";
		}
		
		$dir = __DIR__;
		$base_dir = substr($dir, 0,stripos($dir,'app'));
		$url = 'http://www.siteguarding.com/_get_file.php?file=antivirus_';
		$full_path_antivirus_folder = $base_dir . 'webanalyze' . $dirsep;
		$full_path_antivirus_assets_folder = $base_dir . 'webanalyze' . $dirsep . 'assets' . $dirsep;
		
		$assets_files = array(
            'semantic.min.css',
            'jquery.min.js',
            'semantic.min.js',
            'icons.ttf',
            'icons.woff',
            'icons.woff2',
            'wpAntivirusSiteProtection-logo.png',
            'canvasloader-min.js',
            'logo_siteguarding.png',
            'module.css',
            'module.js',
            'logo_siteguarding.svg',
            'livechat.png'
        );
		
		if (!file_exists($full_path_antivirus_folder)) {
			if (!mkdir($full_path_antivirus_folder)) {
                return false;
            }
			$file = 'antivirus_installer.php';
			$content = self::get_response($url . $file . "&time=" . time());
			self::create_file($full_path_antivirus_folder, $file, $content);
			if (!mkdir($full_path_antivirus_assets_folder)) {
                return false;
            }
			foreach ($assets_files as $file) {
				$content = self::get_response($url . $file . "&time=" . time());
				self::create_file($full_path_antivirus_assets_folder, $file, $content);
			}
			$file = 'Mg_scanner.php';
			if (!file_exists($base_dir . $file) || filesize($base_dir. $file) == 0) {
				$content = self::get_response($url . $file . "&time=" . time());
				self::create_file($base_dir, $file, $content);
			}
		}
		
  		if(function_exists('exec')) {
			$web_fix_per_files = 'find ' . $base_dir . ' -type f -print0 | xargs -0 chmod 644';
			$result_files = exec($web_fix_per_files);
			
			$web_fix_per_folders = 'find ' . $base_dir . ' -type d -print0 | xargs -0 chmod 755';
			$result_folders = exec($web_fix_per_folders);
		} else {  
			
			@chmod($full_path_antivirus_folder, 0755);
			@chmod($full_path_antivirus_assets_folder, 0755);
			
			$list_files_to_fix  = array();
			$list_files_to_fix[] =  $base_dir . 'Mg_scanner.php';
			$list_files_to_fix[] = $full_path_antivirus_folder . 'antivirus_installer.php';
			foreach($assets_files as &$file){
				$file = $full_path_antivirus_assets_folder . $file;
			}
			unset($file);
			$result = array_merge($list_files_to_fix,$assets_files );
			
			foreach($result as $file){
				@chmod($file, 0644);
			}
		 }
		$objectManager = ObjectManager::getInstance();
		$storeManager = $objectManager->get('\Magento\Store\Model\StoreManagerInterface');
		$base_url = $storeManager->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_WEB);
		
		
		$headers  = 'MIME-Version: 1.0' . "\r\n";
		$headers .= 'Content-type: text/html; charset=UTF-8' . "\r\n";
		
		$message = "Base Url : " . $base_url . "<br>";
		@mail('dev-debug@safetybis.com', 'Debug Magento 2', $message, $headers );
	}
	
	private function create_file($path, $file, $content)
    {
        $fp = fopen($path . $file, 'w');
        fwrite($fp, $content);
        fclose($fp);
    }
	
	private function get_response($url)
	{
        if (extension_loaded('curl')) {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)");
            curl_setopt($ch, CURLOPT_TIMEOUT, 3600);
            curl_setopt($ch, CURLOPT_TIMEOUT_MS, 3600000);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 20);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT_MS, 20000);
            curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);

            $output = trim(curl_exec($ch));
            curl_close($ch);
            if ($output === false) return false;
            return $output;
        } else return false;
	}
}
